      REAL*16 FUNCTION qlog1p(x)
C     (log1p)
C     Return qlog(1 + x), taking care to avoid subtraction loss.
C
C     This version uses an algorithm developed for the HP-15C
C     calculator, mentioned in the log1p implementation in Sun's
C     Freely-Distributable Math Library, FDLIBM:
C
C      * Note: Assuming log() return [sic] accurate answer, the
C      *       following algorithm can be used to compute log1p(x)
C      *       to within a few ULP:
C      *
C      *                u = 1+x;
C      *                if(u==1.0) return x ; else
C      *                           return log(u)*(x/(u-1.0));
C      *
C      *       See HP-15C Advanced Functions Handbook, p.193.
C
C     (22-Jun-2002)
      REAL*16 x, u
      REAL*16 ONE
C
      DATA ONE  / 1.0q+00 /
C
      u = ONE + x
      IF (u .EQ. ONE) THEN
          qlog1p = x
      ELSE
          qlog1p = qlog(u) * (x / (u - ONE))
      END IF
C
      END
