      REAL*16 FUNCTION QRANDL(X)
C
C     RETURNS PSEUDO RANDOM NUMBERS LOGARITHMICALLY DISTRIBUTED
C     OVER (1,QEXP(X)).  THUS A*QRANDL(LN(B/A)) IS LOGARITHMICALLY
C     DISTRIBUTED IN (A,B).
C
C     OTHER SUBROUTINES REQUIRED
C
C        QEXP(X) - THE EXPONENTIAL ROUTINE
C
C        QRAN(K) - A FUNCTION PROGRAM RETURNING RANDOM QUADRUPLE
C                 PRECISION NUMBERS UNIFORMLY DISTRIBUTED OVER
C                 (0,1).  THE ARGUMENT K IS A DUMMY.
C
C
      REAL*16 QRAN,X
      INTEGER K
      DATA K/1/
C
      QRANDL = QEXP(X*QRAN(K))
      RETURN
C     ---------- LAST CARD OF QRANDL ----------
      END
